#
# spec file for package hp-i40e (Version 2.0.23)
#
# Copyright (c) 2017 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://support.novell.com
#

%define sle_maj %(sed -n '/VERSION = /{s///p;q;}' /etc/SuSE-release)
%define sle_min %(sed -n '/PATCHLEVEL = /{s///p;q;}' /etc/SuSE-release)
%define sle_version %{sle_maj}%{sle_min}

Name: hp-i40e
Summary: Intel(R) 40-10 Gigabit Ethernet Connection Network Driver
Version: 2.0.23
Release: 4.1
Source0: https://kent.dl.sourceforge.net/project/e1000/i40e%20stable/2.0.23/i40e-2.0.23.tar.gz
Source1: i40iw-sles12sp2.tar.bz2
Source2: preamble
License: GPL-2.0
Group: System/Kernel
URL: http://www.intel.com/network/connectivity/products/server_adapters.htm
BuildRequires: %kernel_module_package_buildreqs
BuildRequires: pciutils-ids
Requires: pciutils-ids
BuildRoot: %{_tmppath}/%{name}-%{version}-build

%kernel_module_package -p %_sourcedir/preamble

%description
This package contains support for the Intel(R) 40-10 Gigabit Ethernet Connection.

More specific information on configuring the driver is in
/usr/share/doc/packages/hp-i40e/README

The driver is delivered in multiple binary packages.
The 'hp-i40e' base package provides the common driver documentation, and
updates to the pciutils pci-ids database. The 'hp-i40e-kmp-<flavor>'
sub-packages provide the kernel modules for the specific kernel flavors.

%package KMP
Summary: Intel(R) 40-10 Gigabit Ethernet Connection Network Driver
Group: System/Kernel

%description KMP
This package contains the Intel(R) 40-10 Gigabit Ethernet Connection Network Driver.

More specific information on configuring the driver is in
/usr/share/doc/packages/hp-i40e/README

This sub-package provides the kernel module(s) for the specific kernel flavor as
indicated by the 'hp-i40e-kmp-<flavor>' package name. Driver documentation and
updates to the pciutils pci-ids database are provided by the 'hp-i40e' base
package.

%prep
%setup -a1 -n i40e-%{version}
set -- *
mkdir source
mv "$@" source/
echo "i40e.ko external" > source/src/Module.supported
echo "i40iw.ko external" > source/i40iw/Module.supported
mkdir obj

%build
export MANDIR=%{_mandir}
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}
    %if %{sle_version} == 122
    cp $PWD/obj/$flavor/src/Module.symvers $PWD/obj/$flavor/i40iw
    make -C %{kernel_source $flavor} modules M=$PWD/obj/$flavor/i40iw
    %endif
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export MANDIR=%{_mandir}
export INSTALL_MOD_DIR=%{kernel_module_package_moddir}
for flavor in %flavors_to_build; do
    make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} rpm
    %if %{sle_version} == 122
    make -C %{kernel_source $flavor} modules_install M=$PWD/obj/$flavor/i40iw
    %endif
done
mkdir -p $RPM_BUILD_ROOT/usr/share/pci.ids.d
install -D -m 644 source/pci.updates $RPM_BUILD_ROOT/usr/share/pci.ids.d/pci.ids.intel-i40e-%{version}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man7
install -m 644 -D source/i40e.7 $RPM_BUILD_ROOT/%{_mandir}/man7
gzip -9nf $RPM_BUILD_ROOT/%{_mandir}/man7/*.?

chmod -x source/COPYING source/README

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_mandir}/man7/i40e.7.gz
/usr/share/pci.ids.d/pci.ids.intel-i40e-%{version}
%doc source/COPYING
%doc source/README

%post
if [ -x /usr/bin/merge-pciids -a -x /usr/bin/perl ]; then
    /usr/bin/merge-pciids
else
    echo "ERROR: merge-pciids or perl not found"
fi

%postun
if [ -x /usr/bin/merge-pciids -a -x /usr/bin/perl ]; then
    /usr/bin/merge-pciids
else
    echo "ERROR: merge-pciids or perl not found"
fi

%changelog
* Tue Jul 18 2017 sbahling@suse.com
- Add i40iw module.
  With SLES 12 SP2 we need to build the i40iw module along with the
  i40e to ensure kABI compability between them. We just pull in the
  i40iw source from SLES 12 GA kernel.
* Tue May  2 2017 sbahling@suse.com
- Initial build of i40e driver for HPE.
